# std::enable_shared_from_this<T>::weak_from_this

From cppreference.com
< cpp‎ | memory‎ | enable shared from this

std::weak_ptr<T> weak_from_this() noexcept; | (1) | (since C++17)
std::weak_ptr<T const> weak_from_this() const noexcept; | (2) | (since C++17)

Returns a std::weak_ptr<T> that tracks ownership of *this by all existing std::shared_ptr that refer to *this.

### Notes

This is a copy of the the private mutable `weak_ptr` member that is part of `enable_shared_from_this`.

### Return value

std::weak_ptr<T> that shares ownership of *this with pre-existing std::shared_ptrs

### Example

| This section is incomplete Reason: no example

### See also

shared_ptr (C++11) | smart pointer with shared object ownership semantics (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/memory/enable_shared_from_this/weak_from_this&oldid=98960"